floor = math.floor
random = math.random

function round(n)
	return floor(n*2)-floor(n)
end



--map = {}
particles = {}
pcount = 0
maps = {{}}
timestep = 1
pause = false
gb = true

function insertontile(id,x,y,timestep)
	local map = maps[timestep]
	x,y=floor(x),floor(y)
	if not map[x] then
		map[x] = {}
	end
	map[x][y] = id
end

function gettile(x,y,timestep)
	local map = maps[timestep]
	x,y=floor(x),floor(y)
	if not map[x] then
		return nil
	end
	return map[x][y]
end

function removefromtile(x,y)	--unnecessary?
	x,y=floor(x),floor(y)
	map[x][y] = nil
end

function newparticle(x,y,timestep)
	local p = {x=x,y=y}
	pcount=pcount+1
	particles[pcount]=p
	p.id = pcount
	insertontile(p.id,x,y,timestep)
end

function destroyparticle(id)
	--local p = particles[id]
	--removefromtile(p.x,p.y)
	particles[id]=nil
end

function checkliveparticle(p,timestep)
	local liveneighborscount = 0
	for x=p.x-1,p.x+1 do
	for y=p.y-1,p.y+1 do
		if x~=p.x or y~=p.y then	--so we dont check ourselves
		local id2 = gettile(x,y,timestep)
			if id2 and id2~=0 then
				liveneighborscount=liveneighborscount+1
			else	--it is dead, lets check if it's been checked
				local id3 = gettile(x,y,timestep+1)
				if not id3 then	--not checked
					checkdeadparticle(x,y,timestep)
				else
					--print(id3)
				end
			end
		end
	end
	end
	if liveneighborscount < 2 or liveneighborscount > 3 then
		insertontile(0,p.x,p.y,timestep+1)	--dies
		destroyparticle(p.id)
	else 
		insertontile(p.id,p.x,p.y,timestep+1)	--lives on
	end
end

function checkdeadparticle(ax,ay,timestep)
	local liveneighborscount = 0
	for x=ax-1,ax+1 do
	for y=ay-1,ay+1 do
		if x~=ax or y~=ay then	--so we dont check ourselves
		local id2 = gettile(x,y,timestep)
			if id2 and id2~=0 then
				liveneighborscount=liveneighborscount+1
			end
		end
	end
	end
	if liveneighborscount == 3 then		--reproduces
		newparticle(ax,ay,timestep+1)
	else
		insertontile(0,ax,ay,timestep+1)	--so it is only checked once
	end
end

function updategame()
	maps[timestep+1] = {}
	for x=1,pcount do
		local p=particles[x]
		if p then
		checkliveparticle(p,timestep)
		end
	end
	if gb then maps[timestep] = nil end
	timestep=timestep+1
end

function love.load()
	redpixel = love.graphics.newImage("redpixel.png")
	--local bluepixel = love.graphics.newImage("bluepixel.png")
	--pixels = {[0]=redpixel,[1]=bluepixel}
	for x=1,15000 do
		local x=random(0,800)
		local y=random(0,600)
		local id = gettile(x,y,timestep)
		if not id then
			newparticle(x,y,timestep)
		end
	end
end

function love.update(dt)
	if love.mouse.isDown("l") then
		local x, y = love.mouse.getPosition() 
		local id = gettile(x,y,timestep)
		if not id or id == 0 then
			newparticle(x,y,timestep)
		end
	end
	if not pause then
		updategame()
	end
end

function love.keypressed(key, unicode)
	if (key == "escape") then pause = not pause end
end
function love.draw()
	for x=1,pcount do
		local p = particles[x]
		if p then
		love.graphics.draw(redpixel, p.x, p.y)
		end
	end
end
		